"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var logLevels = [
    "error",
    "warn",
    "info",
    "verbose",
    "debug",
    "silly",
];
var StandardizedLogger = /** @class */ (function () {
    function StandardizedLogger(log) {
        this.log = log;
        this.logLevel = 6 /* all */;
    }
    StandardizedLogger.prototype.error = function (message) {
        var meta = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            meta[_i - 1] = arguments[_i];
        }
        if (this.logLevel >= 0 /* error */) {
            this.log("error", message, meta);
        }
    };
    StandardizedLogger.prototype.warn = function (message) {
        var meta = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            meta[_i - 1] = arguments[_i];
        }
        if (this.logLevel >= 1 /* warn */) {
            this.log("warn", message, meta);
        }
    };
    StandardizedLogger.prototype.info = function (message) {
        var meta = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            meta[_i - 1] = arguments[_i];
        }
        if (this.logLevel >= 2 /* info */) {
            this.log("info", message, meta);
        }
    };
    StandardizedLogger.prototype.verbose = function (message) {
        var meta = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            meta[_i - 1] = arguments[_i];
        }
        if (this.logLevel >= 3 /* verbose */) {
            this.log("verbose", message, meta);
        }
    };
    StandardizedLogger.prototype.debug = function (message) {
        var meta = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            meta[_i - 1] = arguments[_i];
        }
        if (this.logLevel >= 4 /* debug */) {
            this.log("debug", message, meta);
        }
    };
    StandardizedLogger.prototype.silly = function (message) {
        var meta = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            meta[_i - 1] = arguments[_i];
        }
        if (this.logLevel >= 5 /* silly */) {
            this.log("silly", message, meta);
        }
    };
    return StandardizedLogger;
}());
var LoggerImpl = /** @class */ (function (_super) {
    __extends(LoggerImpl, _super);
    function LoggerImpl(oe) {
        var _this = _super.call(this, function (level, message, meta) { return _this._printers[level]({
            level: level, message: message, meta: meta,
            colorize: _this._colorize,
            listener: _this._logListener,
            timestamp: _this._timestamp ? _this._timestamp(new Date()) : undefined,
        }); }) || this;
        _this.oe = oe;
        _this.defer = new StandardizedLogger(function (level, message, meta) { return _this._printers[level]({
            level: level, message: message,
            meta: meta.map(function (x) { return typeof x === "function" ? x() : x; }),
            colorize: _this._colorize,
            listener: _this._logListener,
            timestamp: _this._timestamp ? _this._timestamp(new Date()) : undefined,
        }); });
        _this._printers = {};
        _this._colorize = false;
        _this.level("all");
        _this.errorLevels(["error"]);
        return _this;
    }
    LoggerImpl.prototype.level = function (lv) {
        if (lv) {
            this.logLevel = levelLiteralToEnum(lv);
            this.defer.logLevel = this.logLevel;
        }
        return this;
    };
    LoggerImpl.prototype.colorize = function (v) {
        this._colorize = v;
        return this;
    };
    LoggerImpl.prototype.timestamp = function (v) {
        this._timestamp = v;
        return this;
    };
    LoggerImpl.prototype.errorLevels = function (levels) {
        var _this = this;
        logLevels.forEach(function (level) { return _this._printers[level] = _this.oe.out; });
        levels.forEach(function (level) { return _this._printers[level] = _this.oe.err || _this.oe.out; });
        return this;
    };
    LoggerImpl.prototype.listen = function (hd) {
        this._logListener = hd;
        return this;
    };
    return LoggerImpl;
}(StandardizedLogger));
exports.LoggerImpl = LoggerImpl;
function levelLiteralToEnum(level) {
    switch (level) {
        case "silent": return -1 /* silent */;
        case "error": return 0 /* error */;
        case "warn": return 1 /* warn */;
        case "info": return 2 /* info */;
        case "verbose": return 3 /* verbose */;
        case "debug": return 4 /* debug */;
        case "silly": return 5 /* silly */;
        case "all": return 6 /* all */;
    }
}
