"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("util");
var core_1 = require("../core");
function createNodeLogger() {
    var logger = new core_1.LoggerImpl({
        out: function (i) { process.stdout.write(output(i)); },
        err: function (i) { process.stderr.write(output(i)); },
    });
    logger.timestamp(function (date) { return date.toISOString(); });
    return logger;
}
exports.default = createNodeLogger;
function output(i) {
    var text;
    if (i.timestamp) {
        if (i.colorize) {
            text = util_1.format.bind(null, "[" + i.timestamp + "][" + colorizer(i.level) + "] " + i.message + "\n").apply(null, i.meta);
        }
        else {
            text = util_1.format.bind(null, "[" + i.timestamp + "][" + i.level + "] " + i.message + "\n").apply(null, i.meta);
        }
    }
    else {
        if (i.colorize) {
            text = util_1.format.bind(null, "[" + colorizer(i.level) + "] " + i.message + "\n").apply(null, i.meta);
        }
        else {
            text = util_1.format.bind(null, "[" + i.level + "] " + i.message + "\n").apply(null, i.meta);
        }
    }
    if (i.listener) {
        i.listener(text);
    }
    return text;
}
function colorizer(level) {
    switch (level) {
        case "error": return "\u001B[31m" + level + "\u001B[39m"; // Red
        case "warn": return "\u001B[33m" + level + "\u001B[39m"; // Yellow
        case "info": return "\u001B[32m" + level + "\u001B[39m"; // Green
        case "verbose": return "\u001B[36m" + level + "\u001B[39m"; // Cyan
        case "debug": return "\u001B[34m" + level + "\u001B[39m"; // Blue
        case "silly": return "\u001B[35m" + level + "\u001B[39m"; // Magenta
    }
    return level;
}
